﻿using Syncfusion.DocIO.DLS;
using Syncfusion.UI.Xaml.RichTextBoxAdv;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Text.RegularExpressions;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace invalidregularexpression
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            richTextBoxAdv.SelectionChanged += RichTextBoxAdv_SelectionChanged;
        }
        private void RichTextBoxAdv_SelectionChanged(object obj, Syncfusion.UI.Xaml.RichTextBoxAdv.SelectionChangedEventArgs args)
        {
            //Determines boolean state of image selection.
            bool imageSelected = false;
            if (richTextBoxAdv.Selection.Start.Paragraph == richTextBoxAdv.Selection.End.Paragraph)
            {
                //Determines the hierarchial index of start position.
                string start = richTextBoxAdv.Selection.Start.HierarchicalIndex;
                double startOffset = Convert.ToDouble(start.Substring(start.LastIndexOf(";") + 1));

                //Determines the hierarchial index of end position.
                string end = richTextBoxAdv.Selection.End.HierarchicalIndex;
                double endOffset = Convert.ToDouble(end.Substring(end.LastIndexOf(";") + 1));

                if (startOffset + 1 == endOffset)
                {
                    double offset = 0;
                    ParagraphAdv paragraph = richTextBoxAdv.Selection.End.Paragraph;
                    for (int i = 0; i < paragraph.Inlines.Count; i++)
                    {
                        Inline inline = paragraph.Inlines[i];

                        if (inline is SpanAdv)
                        { offset += (inline as SpanAdv).Text.Length; }
                        else
                            offset += 1;
                        // Checks whether the image is selected or not.
                        if (offset == endOffset && inline is ImageContainerAdv)
                        {
                            imageSelected = true;
                        }
                    }
                }
            }
            ImageSelection.Text = "ImageSelected :" + " " + imageSelected.ToString();
        }
    }
}
